#####################################
### M5StickV  AD1115 FFT Sample   ###
#####################################
import lcd 
import sys
import image
import math
import array
from machine import Timer
from machine import I2C
from Maix import FFT 

#######################################
### AD sampling Callback function   ###
#######################################
def time_callback(fp):                                      #ADTvOp̃R[obN֐
  global adc_counter
  global i2c
  global databuf512 
  global haning_win
  i2c.writeto(72, b'\x01\x0D\xE3')                          #ADC OS bit = 0
  i2c.writeto(72, b'\x00')                                  #AD f[^[hR}h
  ad = int.from_bytes(i2c.readfrom(72, 2),'big')            #ADC f[^[h (tIvVȂj 
  if(ad>32767) : ad -= 65536                                #Unsigned -> Signedϊ
  if(adc_counter == 512): adc_counter = 0                   #ADC counter~bg
  databuf512[adc_counter]=int(ad * haning_win[adc_counter]) #f[^obt@ɏ ֐Z
  adc_counter+=1                                            #ADC TvJE^CNg
  i2c.writeto(72, b'\x01\x8D\xE3')                          #ADC OS bit = 1 ADϊX^[g

############
### Init ###
############
lcd.init()
img=image.Image()                                           #Otp摜obt@
grid_img=image.Image()                                      #XYp摜obt@
i2c = I2C(I2C.I2C0,freq=400000,scl=34,sda=35)               #I2C(Grove connector)ݒ
try:                                                        #ADRo[^̐ڑ`FbN
  junk1 = i2c.writeto(72, b'\x01\x0D\xE3')                  #0.256V single shot AD start
except:
  lcd.draw_string(10,100,"Error:AD1115 not found")          #ADRo[^ɐڑłȂƂLCDɃG[\exit()
  sys.exit()

tim = Timer(Timer.TIMER0, Timer.CHANNEL0, mode=Timer.MODE_PERIODIC, period=2,   #R[obN֐̐ݒ.2msecԊu
      unit=Timer.UNIT_MS, callback=time_callback,arg=time_callback, start=False, priority=1) 

Average_count = 8                                                               # Ax[W
av_counter = 0                                                                  # Ax[WOJE^
adc_counter=0                                                                   #
haning_win =[(0.5- 0.5 * math.cos(2.0*math.pi*(float(ii)/512.0))) for ii in range(512)] # njOz쐬
databuf512 = array.array('i',[0 for ii in range(512)])                          # f[^obt@ 4 byte signed 
averaging_buf = array.array('i',[0 for ii in range(256 * Average_count)])       # Ax[WOobt@ 4 byte signed

###############
### XY AXIS ###
###############
(Org_x,Org_y) = (30 ,120)                                                       # Ot_ʒu 
(X_width,Y_height) = (200 ,100)                                                 # XY

junk1=grid_img.draw_line(Org_x,Org_y,Org_x+X_width,Org_y,color=(0,255,0))       # X`
X_axis_ratio = X_width/math.log10(256.0)                                        # XLOGXP[̔䗦
X_scales = ((int(math.log10(10) * X_axis_ratio ), "10 Hz"),                     # X̃ʒuƕݒ
            (int(math.log10(50) * X_axis_ratio ), "50"),
            (int(math.log10(100) * X_axis_ratio ),"100"),
            (int(math.log10(200) * X_axis_ratio ) ,"200"))
for (xx,label) in X_scales:                                                     # X̃ƕ`
  junk1=grid_img.draw_line(xx+Org_x,Org_y,xx+Org_x,Org_y-5,color=(0,255,0))
  junk1=grid_img.draw_string(xx+Org_x-10,Org_y+5,label,color=(0,255,0))

junk1=grid_img.draw_line(Org_x,Org_y,Org_x,Org_y-Y_height,color=(0,255,0))      # Y`
Y_scales = ((0,"100u"), (-20," 1m"), (-40,"10m"), (-60,"100m"), (-80," 1A"))   # Ỹʒuƕݒ
for (yy,label) in Y_scales:                                                     # Ỹƕ`
  junk1=grid_img.draw_line(Org_x,Org_y+yy,Org_x+5,Org_y+yy,color=(0,255,0))
  junk1=grid_img.draw_string(0,Org_y+yy-7,label,color=(0,255,0))

###############
### LOOP    ###
###############
tim.start()                                                                     # ADRo[^TvOJn
while True:
  if(adc_counter == 512):                                                       # f[^obt@tɂȂ珈Jn
      tim.stop()                                                                # ADRo[^~ (LCD`撆ɃR[obN~܂邽߁j
      adc_counter = 0
      FFTimg = FFT.run(bytes(databuf512), 512, 0x0ff)                           # FFTs 9ĩo^tCZ 8Vtg_Ew
      (px,py)=(Org_x, Org_y)
      for xx in range(1,256,1):                                                 # FFTʏ[v@
        averaging_buf[xx+256*av_counter] = int(10.0*math.log10(FFTimg[xx][0]**2+FFTimg[xx][1]**2)+0.5)  # fLoglɕϊB
        av_counter += 1                                                         # g8Ax[WO
        if(av_counter >= Average_count):av_counter = 0
        log_x = int(math.log10(xx) * X_axis_ratio )                             # X250Hz256̂200dot͈͂Logϊ
        sum=0                                                                   # Ax[WOpϐ
        for ii in range(Average_count):                                         # Ax[WOobt@̉Z[v
          sum += averaging_buf[xx+256*ii]
        dbv = int(sum / Average_count)                                          # LCD1dot 1dBV/rtHz 120dot120dB͈̔͂\
        junk1=img.draw_line(px,py,log_x+Org_x,Org_y-dbv)                        # Ot̕`
        (px,py)=(log_x + Org_x, Org_y-dbv)
      junk1 = lcd.display(img.add(grid_img))                                    # XỶ摜ƃOt摜̃}[WLCDւ̓]
      junk1 = img.clear()                                                       # Ot摜obt@
      tim.start()                                                               # ADC Ro[^TvOJn

